#!/bin/zsh -f
#   Look, man, this script just currently uses some zsh specific features.
# It currently works, I'm just too lazy to adapt it,
# and I see no point in trying to do so, as long as it works:
# if you don't have zsh, just get it for free
# from any good linux or unix ftp site
# (e.g. ftp.ibp.fr, sunsite.doc.ic.ac.uk, sunsite.unc.edu).
# The original site for zsh is http://www.mal.com/zsh
# It's a great shell, and if you try it, you keep it.
#   Now, if by chance you *do* adapt the program,
# then I'll be glad to include your changes.
# Perhaps Perl or SCSH, for instance, would be appropriate tools for that.
#   All this is due to be made obsolete anyway
# once Tunes is successfully bootstrapped...


#Bizarre bug:
# I have "no such file or directory" errors
# when making a patch for 0.0.0.27 from 0.0.0.25
# for files and dirs below src/HLL (that doesn't exist in .25).
# but they disappear whenever I use -x to debug it !!!
#Way round:
# do use the -x flag, by exporting ZSH_FLAGS=-x
# so that "make patch" gives it to build.sh


setopt EXTENDED_GLOB NO_NOMATCH NUMERIC_GLOB_SORT BRACE_CCL RC_QUOTES
#unsetopt

############################ Generating patches ############################

LF='
'
: ${RM:=rm} ${CP:=cp} ${MV:=mv}
: ${ARCHIVETYPE:=.zip}

### Using patch ###
applypatch () {
  case "$1" in
    *.gz|*.Z|*.z) zcat $1 ;;
    *) cat $1 ;;
  esac | patch -E -p0 2>&1 | tee zap
  echo
  echo 'All results of the patch process were put in file "zap".'
}

getversion () {
  . ./version
  echo $MAJOR_VERSION.$MINOR_VERSION.$PATCH_LEVEL.$INTERNAL_REVISION
}

compare_versions () {
  if cmp --silent ${TUNES}/version ${OLDTUNES}/version
  then
    echo 'Old and new distributions have same version number !'
    exit 1
  else
    return 0  # versions are different as expected.
  fi
}

mkpatch () {
  OLDVER=$(cd $OLDTUNES ; getversion)
  PATCH=${PATCH_PREFIX}${OLDVER}-${TUNESVER}

  if [ -f $PATCH ] ; then ${=RM} $PATCH ; fi
  PATCH

  comprpatch
}


mkpatchxxx () {
  OLDVER=$(cd $OLDTUNES ; getversion)
  PATCH=${PATCH_PREFIX}${1}.${OLDVER}+${TUNESVER}

  if [ -f $PATCH ] ; then ${=RM} $PATCH ; fi
  PATCHDIR ${2}

  comprpatch
}

mkpatchdoc () {
  mkpatchxxx doc doc/
}

mkpatchsrc () {
  mkpatchxxx src src/
}

mkpatchbin () {
  mkpatchxxx bin ""
}


comprpatch () {
  #OLDVER=$(cd $OLDTUNES ; getversion)
  #PATCH=${PATCH_PREFIX}${OLDVER}-${TUNESVER}
  ls -sl ${PATCH} >&2
  ${=COMPR} ${PATCH}
  ls -sl ${PATCH}${=COMPRSUFFIX} >&2
}

# DIFFOPTS -- options for diff'ing
# to save a little space, use -C0 instead of --unified
[ -n "$DIFFOPTS" ] ||
DIFFOPTS=(-uN)

diff0 () {
  #echo diff $DIFFOPTS $@
  diff $DIFFOPTS $@
}

mkdiff () {
  if [ -f "$1" ] ; then
    if [ -f "$2" ] ; then
      diff0 "$1" "$2"
    else
      #echo "Only in $(dirname $1): $(basename $1)"
      AA=($(Touch "$2"))
      diff0 "$1" "$2"
      /bin/rm "$2"
      removedir $AA
    fi
  else
    if [ -f "$2" ] ; then
      #echo "Only in $(dirname $2): $(basename $2)"
      AA=($(Touch "$1"))
      diff0 "$1" "$2"
      /bin/rm "$1"
      removedir $AA
    else
      echo "File not found $2" >&2
    fi
  fi
}

Touch () {
  makedir $(dirname $1)
  touch -d '00:00:00GMT 01 Jan 1970' $1
}

makedir () {
  if [ -n "$1" -a ! -d "$1" ] ; then
    echo $1
    makedir $(dirname $1)
    mkdir $1
  fi
}
removedir () {
  if [ -n "$*" ] ; then
    rmdir $@
  fi
}

function PATCH () {(
  #setopt -x
  PATCHDIR ""
  PATCHDIR src/
  PATCHDIR doc/

 ### add as many -x as necessary to exclude all unneeded files
 ### that may be generated or hand-written (temporary files, then)
#  mkdiff --recursive -X doc/archive -x '*-list' \
#    -x '.tmp*' -x 'patch.*' -x 'version.h' \
#    -x '*.[oasilbxpZ]' -x '*.m4f' \
#    -x '*.obj' -x '*.bin' -x '*.exe' -x '*.co*' \
#    -x '*.?rf' -x '*.lst' -x '*.map' \
#    -x '*.tmp' -x '*.$$$' \
#    -x '*~' -x '#*#' \
#    -x '*.bak' -x '*.orig' -x '*.rej' \
#    -x 'z[aeiou]p' -x foo -x bar -x test -x 'core*' \
#    ${OLDTUNES} ${TUNES} >> ${PATCH}
#  A=$? ; if [ $A = 1 ] ; then return 0 ; else return $A  ; fi
)}

function PATCHDIR () {(
  : PATCHDIR
  NFILES=$(_LOGfiles $TUNES $1)
  : NFILES $NFILES
  OFILES=$(_LOGfiles $OLDTUNES $1)
  : OFILES $OFILES
  AFILES=$(echo "$NFILES$LF$OFILES" | sort -u)
  : AFILES $AFILES
  cd $TUNES
  for i in ${=AFILES} ; do
    mkdiff $OLDTUNES/$i $i >> $PATCH
  done
)}

clean () {
   BAD="`find . '(' -name '*.orig' \
		-o -name '*.rej' \
		-o -name '*.bak' \
		-o -name '.tmp*' \
		-o -name 'patch.*' \
		-o -name 'version.h' \
		-o -name '*.[oasilbxpzZ]' \
		-o -name '*.m4f' \
		-o -name '*.obj' \
		-o -name '*.bin' \
		-o -name '*.exe' \
		-o -name '*.co[m12]' \
		-o -name '*.[cx]rf' \
		-o -name '*.lst' \
		-o -name '*.map' \
		-o -name '*.tmp' \
		-o -name '*.$$$' \
		-o -name '*~' \
		-o -name '#*#' \
		-o -name 'z[aeiou]p' \
		-o -name foo \
		-o -name bar \
		-o -name test \
		-o -name 'core*' \
		-o -name tunesinsttool \
		')' \
		-print`"
   echo $BAD >&2
   /bin/rm -f ${=BAD}
}


################### LOGGING FUNCTIONS (FOR INCREMENTAL SAVE) #############
########################### using zip/unzip ##############################
function syssvdir () { echo ${SYSSVDIR:-$TUNES} }
MYTMP=/tmp

function SVTDOC () { LOGOUT tunesdoc $TUNES/doc }
function SVTBIN () { LOGOUT tunesbin $TUNES/ }
function SVTSRC () { LOGOUTtunessrc $TUNES/src }
function SVTUNES () {( SVTDOC ; SVTBIN ; SVTSRC )}

function _LOGfiles () {
  #
  # Beware:
  # * it will fail if bogus characters lie in filenames...
  # * it will modify options and variables
  #
  setopt NULL_GLOB GLOB_DOTS
  LOGDIR=${1:-${LOGDIR:-$HOME}}
  LOGSUBDIR=$2 ; if [ -z "$2" ] ; then FILES= ; fi
  : _LOGfiles $LOGDIR $LOGSUBDIR
  # if [ -z "$LOGRC" ] ; then LOGRC=.Logrc ; fi

  cd $LOGDIR &&
  {
    if [ -f .Logrc ] ; then
        FILES0=($(cd ./$LOGSUBDIR
    	     cat .Logrc | grep -v '^[#lrA-Z]' |
     	     ( while read c f x ; do eval echo "$f" ; # '$c $f $x'
    	       done)))
        for i in ${=FILES0} ; do
          if [ -d ${LOGSUBDIR}$i -a ! -h ${LOGSUBDIR}$i ]
          then
            J=(${LOGSUBDIR}$i/**/*)
            for j in $J
            do if [ -d $j -a ! -h $j ]
    	   then : echo $j/
    	   else echo $j ; fi
            done
          else echo ${LOGSUBDIR}$i
          fi
        done
        FILES=($FILES $=FILES0)
        SUBDIRS=($(cat ${LOGSUBDIR}.Logrc | grep '^r' |
      	      cut -d'	' -f1 | cut -d' ' -f2))
        for i in $SUBDIRS ; do _LOGfiles $LOGDIR ${LOGSUBDIR}${i}/ ; done
    else
        FILES=($(echo **/*))
	for i in $FILES ; do echo $i ; done
    fi
  }
}

function LOGOUT () {(
  #
  # Update LOG FILE from LOGged DIRectory
  # (copy, in the case of .tgz archives)
  #
  setopt NULL_GLOB GLOB_DOTS
  if [ -n "$1" ] ; then LOGFILE=$1 ;
    if [ -n "$2" ] ; then LOGDIR=$2 ; fi ; fi
  LOGLOG=$MYTMP/Log-$HOST--$LOGFILE.log
  #LOGSUBDIR=$3 ; if [ -z "$3" ] ; then : > $LOGLOG ; FILES= ; fi
  SVDIR=$(syssvdir)

  _LOGfiles > $LOGLOG

  cd $LOGDIR &&
  { echo " Saving important files in $LOGDIR:" #".../$LOGSUBDIR:"
    case "$ARCHIVETYPE" in
      .zip) zip -uy9r -n .gz /$SVDIR/${LOGFILE}.zip ${=FILES} ;; # -@ <$LOGLOG
      .tgz) tar zcvf /$SVDIR/$LOGFILE.tgz ${=FILES} ;;
      .tbz) tar --use-compress-program bzip \
		-cvf /$SVDIR/$LOGFILE.tbz ${=FILES} ;;
    esac
  }
)}

function LOGIN () {(
  #
  # Update LOGged DIRectory from LOG FILE
  # (copy, in the case of .tgz archives)
  #
  if [ -n "$1" ] ; then LOGFILE=$1 ;
    if [ -n "$2" ] ; then LOGDIR=$2 ; fi ; fi
  cd $LOGDIR &&
  SVDIR=$(syssvdir)
  case "$ARCHIVETYPE" in
      .zip) unzip -uo /$SVDIR/$LOGFILE.zip ;;
      .tgz) tar zxvf /$SVDIR/$LOGFILE.tgz ;;
      .tbz) tar --use-compress-program bzip \
		-xvf /$SVDIR/$LOGFILE.tbz ;;
  esac
)}

function CLOG () {(
  #
  # clean logfile
  # only used for .zip archives,
  # that allow incremental save and file removing from archive
  #
  setopt NULL_GLOB
  if [ -n "$1" ] ; then LOGFILE=$1 ;
    if [ -n "$2" ] ; then LOGDIR=$2 ; fi ; fi
  SVDIR=$(syssvdir)
  LOGLOG=$MYTMP/Log-$HOST--$LOGFILE.log

  GOODFILES=$(cat $LOGLOG)
  : GF $GOODFILES
  ZF=$(unzip -l /$SVDIR/$LOGFILE.zip | cut -c28-)
  : ZF $ZF
  ZF=(${=ZF})
  : ZF $ZF
  ZF=$ZF[7,-3]
  : ZF $ZF
  ZIPPEDFILES=${=ZF}

  : ZIPPEDFILES=$ZIPPEDFILES
  : ZIPPY $ZIPPEDFILES[10,20]
  : GOODFILES=$GOODFILES
  : GOODY $GOODFILES[10,20]

  BADFILES=$(Set_Difference "$ZIPPEDFILES" "$GOODFILES")
  : BF $BADFILES
  if [ -n "$BADFILES" ] ; then
    zip -d /$SVDIR/$LOGFILE $=BADFILES
  fi

  ### doesn't work: LOGOUT uses zip -r, so that all files below
  ### a zip -r 'ed directory will be considered as BAD !!!
)}

function Is_Element () {(
  for i in ${=2} ; do if [ "$1" = "$i" ]; then return 0 ; fi ; done
  return 1
)}

function Set_Difference () {
# works for sets as IFS-separated list, not as arrays
  for i in ${=1} ; do if ! Is_Element $i $2 ; then echo $i ; fi ; done
}


############################# Report Release ################################

function newtoold () {
	${=RM} -rf ${OLDTUNES}.bak
	${=MV} ${OLDTUNES} ${OLDTUNES}.bak
	${=CP} -dpR ${TUNES} ${OLDTUNES}
	increment_version
}

function repl () {(
  eval "prog=($1)" ; shift
  eval "FILES=($1)" ; shift
  TMPFILE==(echo)
  for i in $FILES ; do
    $prog $@ < $i > $TMPFILE &&
    (cmp --silent $TMPFILE $i || mv -f $TMPFILE $i)
    [ -f $TMPFILE ] && =rm -f $TMPFILE
  done
)}
function replperl () { repl perl $@ }
function replsed () { repl sed $@ }

function report_version () {
  VERSION=$(cd $TUNES;getversion)
  (cd $TUNES/doc/www/ &&
   replperl '*.html' -npe '
     s/(\Q<!--INSERT-RELEASE-NUMBER-HERE-->\E)[.0-9]*/${1}'$VERSION'/'
  )
}
function increment_version () {
  [ -f $TUNES/version ] &&
  cd $TUNES &&
  source ./version &&
  INTERNAL_REVISION=$[1+$INTERNAL_REVISION] &&
  (cat <<-END > version
	MAJOR_VERSION=$MAJOR_VERSION
	MINOR_VERSION=$MINOR_VERSION
	PATCH_LEVEL=$PATCH_LEVEL
	INTERNAL_REVISION=$INTERNAL_REVISION
END
  ) &&
  echo "Incremented version to $(getversion)"
}

########################## interactive use only #############################

function srcfiles () {
  echo info/{i386*,BIOS-API}.nfo src/LLL/**/*.{S,m4}
}

function t () {

}

#function main () {
  "$@"
#}
